# BBOSS Copyright (C) 2019-2021, Laurent Marchelli
# SPDX-License-Identifier: GPL-3.0-or-later

variables:
  ANSIBLE_FORCE_COLOR: "yes"
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - quality
  - tests
  - deploy

default:
  before_script:
    - source venv "${VENV_HYPER_BOX_NAME}"

# ----------------------------------------------------------------------------
#                       Job base templates
# ----------------------------------------------------------------------------
.default_job: &default_job
  stage: quality
  tags:
    - cpu1
  dependencies: []
  only: &default_only
    refs: ['schedules']

.tests_job: &test_job
  <<: *default_job
  stage: tests
  tags:
    - cpu6
  script:
    - molecule test

.deploy_job: &deploy_job
  <<: *default_job
  stage: deploy
  tags:
    - cpu6
  script:
    - vagrant up package
    - vagrant destroy -f package
    - vagrant up nexus-stack nexus-client --provision-with hosts
    - vagrant up deploy
  after_script:
    - vagrant destroy -f

# ----------------------------------------------------------------------------
#                           Stages jobs
# ----------------------------------------------------------------------------
quality:ansible-lint:
  <<: *default_job
  script:
    - ansible-lint

quality:yamllint:
  <<: *default_job
  script:
    - yamllint -s .

tests:centos7.6:
  <<: *test_job
  variables:
    VENV_HYPER_BOX_NAME: centos7.6

deploy:centos7.6:
  <<: *deploy_job
  variables:
    VENV_HYPER_BOX_NAME: centos7.6
  needs: ["tests:centos7.6"]

tests:centos7.8:
  <<: *test_job
  variables:
    VENV_HYPER_BOX_NAME: centos7.8

deploy:centos7.8:
  <<: *deploy_job
  variables:
    VENV_HYPER_BOX_NAME: centos7.8
  needs: ["tests:centos7.8"]

# tests:stretch:
#   <<: *test_job
#   variables:
#     VENV_HYPER_BOX_NAME: stretch

# deploy:stretch:
#   <<: *deploy_job
#   variables:
#     VENV_HYPER_BOX_NAME: stretch
#   needs: ["tests:stretch"]

# tests:buster:
#   <<: *test_job
#   variables:
#     VENV_HYPER_BOX_NAME: buster

# deploy:buster:
#   <<: *deploy_job
#   variables:
#     VENV_HYPER_BOX_NAME: buster
#   needs: ["tests:buster"]

tests:bionic:
  <<: *test_job
  variables:
    VENV_HYPER_BOX_NAME: bionic

# deploy:bionic:
#   <<: *deploy_job
#   variables:
#     VENV_HYPER_BOX_NAME: bionic
#   needs: ["tests:bionic"]

tests:focal:
  <<: *test_job
  variables:
    VENV_HYPER_BOX_NAME: focal

# deploy:focal:
#   <<: *deploy_job
#   variables:
#     VENV_HYPER_BOX_NAME: focal
#   needs: ["tests:focal"]
